class dyndns::client {

    package { "ddclient": ensure => installed }

    file { 
        "/etc/ddclient.conf":
         owner   => root,
         group   => root,
         mode    => 600,
         require => Package["ddclient"],
         notify  => Service["ddclient"],
         content => template("dyndns/ddclient.conf.erb");
    }

    service { "ddclient":
        ensure => running,
        subscribe => [ Package["ddclient"], File["/etc/ddclient.conf"] ],
    }

}
