# copyright <sebas @ koumbit.org>
# < josx @ inteorganic.com.ar >
# Licence: GPL
#

class escritorio::oo3conf {

    package { [
       "openoffice.org-common",
       "openoffice.org-l10n-es",
       "openoffice.org-pdfimport"
       ]: ensure => installed
    }
}


class escritorio::oo3conf::fileformat {
    include escritorio::oo3conf

   # we are changing the config file for write, calc and impress for oo3 3.0
   change_oo3_default { [ "writer", "calc", "impress" ]: oo3_version => "-link"; }

   # Configuration file for OO 3.X
   define change_oo3_default($oo3_version) {
     file { "/usr/lib/openoffice/basis$oo3_version/share/registry/modules/org/openoffice/Setup/Setup-$name.xcu":
       owner => root,
       group => root,
       mode => 644,
       source => "puppet:///escritorio/oo30conf/Setup-$name.xcu"
     }
   }
}

class escritorio::oo3conf::extensions {

    define add_extension($archivo) {
        file {
            "/usr/lib/openoffice/share/extension/install/$archivo":
            owner => root,
            group => root,
            mode => 644,
            source => "puppet:///escritorio/oo30conf/$archivo"
        }

        exec { "add_extension_with_unopkg":
            command => "unopkg add -f --shared /usr/lib/openoffice/share/extension/install/$archivo",
            path => "/bin:/sbin:/usr/sbin:/usr/bin",
            require => Package["openoffice.org-common"]
        }
    }
    
    add_extension { "extension": archivo => "Diccionarios-Argentina_1.oxt"; }

}
