# copyright albertorosenberg @ cta.org.ar
# copyright sebas @ cta.org.ar
# Licence: GPL
#

class escritorio::tb {

    package { [
        "thunderbird",
        "thunderbird-locale-es-ar",
        "thunderbird-gnome-support"
        ]: ensure => installed
    }
}

class escritorio::tb2conf {

    include escritorio::tb

    file { "/usr/share/thunderbird/defaults/pref/mailnews.js":
        owner   => root,
        group   => root,
        mode    => 644,
        source  => "puppet:///escritorio/tb2conf/mailnews.js",
        require => Package["thunderbird"]
    }
}

class escritorio::tb3conf {
    include escritorio::tb

    define add_pref($pref_present, $pref_absent) { 
        file { "/etc/thunderbird/pref/thunderbird.js": ensure => present, checksum => mtime }
        line { "off$pref_absent":
            file => "/etc/thunderbird/pref/thunderbird.js",
            line => $pref_absent, 
            ensure => absent,
            require => Package["thunderbird"]
        }
        line { "on$pref_present":
            file => "/etc/thunderbird/pref/thunderbird.js",
            line => $pref_present,
            ensure => present,
            require => Package["thunderbird"]
        }
    }

    add_pref {  "prefencias": 
        pref_present => 'pref("mailnews.database.global.indexer.enabled", false);', 
        pref_absent =>  'pref("mailnews.database.global.indexer.enabled", true);'
    }

}

class escritorio::tb2::extensions {

    svn::checkout { thunderbird-extension:
        repository => "https://svn.redcta.org.ar/proyectos/redcta/trunk/thunderbird",
        local_path => "/dist/svn-redcta",
        local_name => "thunderbid-extensions"
    }

    file { "/usr/share/thunderbird/isp/example-isp.rdf":
        ensure => "/dist/svn-redcta/thunderbid-extensions/agregados/sources/isp/example-isp.rdf"
    }

# TODO: hacer lo andar bien...
#    file { "/usr/lib/thunderbird/extensions/syncmlplugin@funambol.com":
#        ensure => "/dist/svn-redcta/thunderbid-extensions/funambol/dist"
#    }
}

