class login_themes::gdm::carpani_cta {

    debug ("installing gdm login theme carpani-cta")

    package { [
        "gdm"
        ]: ensure => installed
    }

    file {
        "/usr/share/gdm/themes/gdm-carpani-cta":
            ensure  => directory,
            mode    => 644,
            owner   => root,
            group   => root,
            source  => "puppet:///login_themes/gdm-carpani-cta/",
            recurse => "true",
            require => Package[gdm];
    }

    file {
        "/etc/gdm/gdm.conf-custom":
            content => template("login_themes/gdm.conf-custom.erb"),
            owner   => root,
            group   => root,
            mode    => 644,
            require => Package["gdm"],
    }
}
