class ltsp::common {
    package { [
        "ltsp-server",
        "ltspfs"
        ]: ensure => installed }
}

class ltsp::buildclient { 
    include ltsp::common

    exec { "ltsp-build-client":
	command => "ltsp-build-client",
        path    => "/bin:/sbin:/usr/sbin:/usr/bin",
        timeout => "-1",
	creates => "/opt/ltsp/i386",
        before  => [ Exec["ltsp-update-image"] ],
        require => Package["ltsp-server"]
    }

    exec { "ltsp-update-kernels":
        command     => "ltsp-update-kernels",
        path        => "/bin:/sbin:/usr/sbin:/usr/bin",
        refreshonly => true,
        require     => Package["ltsp-server"]
    }

    exec { "ltsp-update-image":
        command     => "chroot /opt/ltsp/i386/ apt-get clean && ltsp-update-image",
        path        => "/bin:/sbin:/usr/sbin:/usr/bin",
        refreshonly => true,
        require     => Package["ltsp-server"]
    }
}
