class nfs_server {

    package { [
        "portmap", 
        "nfs-kernel-server"
	]: ensure => installed
    }
        
    service { [ "nfs-kernel-server", "portmap" ]:
        ensure  => running,
        pattern => "nfsd",
        require => Package["nfs-kernel-server", "portmap" ],
    }
}

define share_dirs_dev($share_root) {

    file { "${share_root}/$name":
        ensure => directory,
        owner  => "root",
        group  => "root",
        mode   => 755,
    }
}

# No lo usamos...
define share_mounts_dev($share_root, $volgroup) {
    mount { "${share_root}/$name":
        ensure  => mounted,
        device  => "${volgroup}/$name",
        atboot  => true,
        fstype  => "ext3",
        options => "defaults,nosuid",
        require => File["${share_root}/$name"],
    }
}

define nfs_share_dev ($shares, $volgroup, $share_access = "*.$domain", $share_options = "rw,sync") {

    include nfs_server

    # $shares is an array
    share_dirs_dev { $shares: share_root => $name }
#   share_mounts { $shares: share_root => $name, volgroup => $volgroup }

    file { "/etc/exports":
        owner => "root",
        group => "root",
        mode => 644,
        content => template("nfs_server/etc-exports-dev.erb"),
        notify => Service["nfs-kernel-server"],
    }
}
